/**CHeaderFile*****************************************************************

  FileName    [parser.h]

  PackageName [parser]

  Synopsis    [Interface with the parser]

  Description [This file describe the interface with the parser. The
  result of the parsing is stored in a global variable called
  <code>parse_tree</code>.]

  SeeAlso     []

  Author      [Marco Roveri]

  Copyright   [ Copyright (c) 1998 by ITC-IRST and Carnegie Mellon University.
  All Rights Reserved. This software is for educational purposes only.
  Permission is given to academic institutions to use, copy, and modify
  this software and its documentation provided that this introductory
  message is not removed, that this software and its documentation is
  used for the institutions' internal research and educational purposes,
  and that no monies are exchanged. No guarantee is expressed or implied
  by the distribution of this code.
  Send bug-reports and/or questions to: nusmv@irst.itc.it. ]

  Revision    [$Id: $]

******************************************************************************/

#ifndef _PARSER_H
#define _PARSER_H

/*---------------------------------------------------------------------------*/
/* Function prototypes                                                       */
/*---------------------------------------------------------------------------*/
EXTERN int yyparse ARGS((void));
EXTERN void Parser_Init ARGS((void));
EXTERN void Parser_OpenInput ARGS((const char *filename));
EXTERN void Parser_CloseInput ARGS((void));
EXTERN int Parser_ReadFromString ARGS((int argc, char **argv, char * head, char *tail, node_ptr *pc));

#endif /* _PARSER_H */
