/**CHeaderFile*****************************************************************

  FileName    [simulate.h]

  PackageName [simulate]

  Synopsis    [External Header File for MC Simulator]

  Description [External Header File for simulation package: simulation
  package provides a set of utilities for traces generation (a trace is a
  possible execution of the model). It performs initial state picking,
  trace inspection, simulation according to different policies (deterministic,
  random, interactive) and with the possibility to specify constraints.]

  Author      [Andrea Morichetti]

  Copyright   [ Copyright (c) 1998 by ITC-IRST and Carnegie Mellon University.
  All Rights Reserved. This software is for educational purposes only.
  Permission is given to academic institutions to use, copy, and modify
  this software and its documentation provided that this introductory
  message is not removed, that this software and its documentation is
  used for the institutions' internal research and educational purposes,
  and that no monies are exchanged. No guarantee is expressed or implied
  by the distribution of this code.
  Send bug-reports and/or questions to: nusmv@irst.itc.it. ]

  Revision    [$Id: $]

******************************************************************************/

#ifndef _SIMULATE
#define _SIMULATE

/*---------------------------------------------------------------------------*/
/* Type declarations                                                         */
/*---------------------------------------------------------------------------*/
typedef enum {Deterministic, Random, Interactive} Simulation_Mode;

/*---------------------------------------------------------------------------*/
/* Function prototypes                                                       */
/*--------------------------------------------------------------------------*/

EXTERN void Simulate_Init ARGS((void));
EXTERN void Simulate_End ARGS((void));
EXTERN bdd_ptr Simulate_ChooseOneState ARGS((bdd_ptr, Simulation_Mode, int));
EXTERN node_ptr Simulate_MultipleSteps ARGS((bdd_ptr, Simulation_Mode, int, int));
EXTERN void store_and_print_trace ARGS((node_ptr, boolean, int));

#endif /* _SIMULATE */





